Package uk.ac.starlink.table.join

## Enum PairMode

- java.lang.Object
- - java.lang.Enum<PairMode>
  - - uk.ac.starlink.table.join.PairMode

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<PairMode>`

      public enum PairMode
      extends java.lang.Enum<PairMode>

  Enumeration used to determine which row links result from a pair match operation.
  See Also:
    `RowMatcher.findPairMatches(PairMode)`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `ALL` | All matches are returned.
    `BEST` | Only the best matches are returned, obtained symmetrically.
    `BEST1` | For each row in table 1, only the best match in table 2 is returned.
    `BEST2` | For each row in table 2, only the best match in table 1 is returned.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getSummary()` | Returns a short summary of the matching policy.
    `boolean` | `mayProduceGroups()` | Indicates whether the result of a match performed in this mode may contain non-trivial related groups of rows.
    `static PairMode` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static PairMode[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### ALL

          public static final PairMode ALL

      All matches are returned.

    - #### BEST

          public static final PairMode BEST

      Only the best matches are returned, obtained symmetrically. Each row from both input tables will appear in at most one RowLink in the result.

    - #### BEST1

          public static final PairMode BEST1

      For each row in table 1, only the best match in table 2 is returned. Each row from table 1 will appear a maximum of once in the result, but rows from table 2 may appear multiple times.

    - #### BEST2

          public static final PairMode BEST2

      For each row in table 2, only the best match in table 1 is returned. Each row from table 2 will appear a maximum of once in the result, but rows from table 1 may appear multiple times.

  - ### Method Detail

    - #### values

          public static PairMode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (PairMode c : PairMode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static PairMode valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### mayProduceGroups

          public boolean mayProduceGroups()

      Indicates whether the result of a match performed in this mode may contain non-trivial related groups of rows. A group represents a match in which an object in one table corresponds to more than object in the other table.
      Returns:
        true iff this mode may result in ambiguous matches
      See Also:
        `MatchStarTables.findGroups(uk.ac.starlink.table.join.LinkSet)`

    - #### getSummary

          public java.lang.String getSummary()

      Returns a short summary of the matching policy.
      Returns:
        short description string